SystemOrganization addCategory: #'EjerciciosPoo-Measure'!

Error subclass: #MeasureConverterException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

Object subclass: #Distance
	instanceVariableNames: 'distanceAmount distanceUnit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!Distance class methodsFor: 'as yet unclassified' stamp: ''!
of: aDistanceAmount in: aMeasureUnit 
	^ self new amount: aDistanceAmount;
		 unit: aMeasureUnit! !

!Distance methodsFor: 'as yet unclassified' stamp: ''!
* anAmount 
	^ Distance of: self amount * anAmount in: self unit! !

!Distance methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 5/30/2012 20:37'!
+ anotherDistance 
	| normalizedSelf normalizedOther |
	normalizedSelf := self convertTo: MeasureUnit centimeter.
	normalizedOther := anotherDistance convertTo: MeasureUnit centimeter.
	^ Distance of: normalizedSelf amount + normalizedOther amount / self unit ratio in: self unit! !

!Distance methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 5/30/2012 20:37'!
- anotherDistance 
	| normalizedSelf normalizedOther |
	normalizedSelf := self convertTo: MeasureUnit centimeter.
	normalizedOther := anotherDistance convertTo: MeasureUnit centimeter.
	^ Distance of: normalizedSelf amount - normalizedOther amount / self unit ratio in: self unit! !

!Distance methodsFor: 'as yet unclassified' stamp: ''!
/ anAmount 
	^ Distance of: self amount / anAmount in: self unit! !

!Distance methodsFor: 'as yet unclassified' stamp: ''!
< anotherDistance 
	^ self amount < (anotherDistance convertTo: self unit) amount! !

!Distance methodsFor: 'as yet unclassified' stamp: ''!
<= anotherDistance 
	^ self < anotherDistance or: self = anotherDistance! !

!Distance methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 5/30/2012 20:37'!
= anotherDistance 
	| retVal |
	retVal := false.
	(anotherDistance isKindOf: Distance)
		ifTrue: [retVal := self amount * self unit ratio = (anotherDistance amount * anotherDistance unit ratio)].
	^ retVal! !

!Distance methodsFor: 'as yet unclassified' stamp: ''!
> anotherDistance 
	^ anotherDistance < self! !

!Distance methodsFor: 'as yet unclassified' stamp: ''!
>= anotherDistance 
	^ self > anotherDistance or: self = anotherDistance! !

!Distance methodsFor: 'as yet unclassified' stamp: ''!
amount
	^ distanceAmount! !

!Distance methodsFor: 'as yet unclassified' stamp: ''!
amount: aDistanceAmount 
	distanceAmount := aDistanceAmount! !

!Distance methodsFor: 'as yet unclassified' stamp: ''!
between: aDistance and: anotherDistance 
	^ self <= anotherDistance and: aDistance <= self! !

!Distance methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 5/30/2012 20:37'!
convertTo: aMeasureUnit 
	^ Distance of: self amount * self unit ratio / aMeasureUnit ratio in: aMeasureUnit! !

!Distance methodsFor: 'as yet unclassified' stamp: ''!
hash
	^ self! !

!Distance methodsFor: 'as yet unclassified' stamp: ''!
max: anotherDistance 
	self > anotherDistance
		ifTrue: [^ self].
	^ anotherDistance! !

!Distance methodsFor: 'as yet unclassified' stamp: ''!
min: anotherDistance 
	self < anotherDistance
		ifTrue: [^ self].
	^ anotherDistance! !

!Distance methodsFor: 'as yet unclassified' stamp: ''!
negated
	distanceAmount := distanceAmount * -1! !

!Distance methodsFor: 'as yet unclassified' stamp: ''!
printOn: aStream 
	aStream nextPutAll: self amount printString.
	aStream nextPutAll: ' '.
	aStream nextPutAll: self unit printString.
	self amount abs > 1
		ifTrue: [aStream nextPutAll: 's']! !

!Distance methodsFor: 'as yet unclassified' stamp: ''!
to: anotherDistance 
	^ self
		to: anotherDistance
		by: (Distance of: 1 in: self unit)! !

!Distance methodsFor: 'as yet unclassified' stamp: ''!
to: anotherDistance by: aStepDistance 
	^ DistanceInterval
		from: self
		to: anotherDistance
		by: aStepDistance! !

!Distance methodsFor: 'as yet unclassified' stamp: ''!
unit
	^ distanceUnit! !

!Distance methodsFor: 'as yet unclassified' stamp: ''!
unit: aMeasureUnit 
	distanceUnit := aMeasureUnit! !

Object subclass: #DistanceInterval
	instanceVariableNames: 'distanceFrom distanceTo distanceStep'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!DistanceInterval class methodsFor: 'as yet unclassified' stamp: ''!
from: aDistance to: anotherDistance by: stepDistance 
	^ self new from: aDistance;
		 to: anotherDistance;
		 by: stepDistance! !

!DistanceInterval methodsFor: 'accessing' stamp: ''!
by
	^ distanceStep! !

!DistanceInterval methodsFor: 'accessing' stamp: ''!
by: aDistance 
	distanceStep := aDistance! !

!DistanceInterval methodsFor: 'accessing' stamp: ''!
do: t1 
	| t2 t3 t4 |
	t3 := 0.
	t4 := self size.
	[t3 < t4]
		whileTrue: [t2 := self from
						+ (Distance of: t3 * self by amount in: self by unit).
			t3 := t3 + 1.
			t1 value: t2]! !

!DistanceInterval methodsFor: 'accessing' stamp: ''!
from
	^ distanceFrom! !

!DistanceInterval methodsFor: 'accessing' stamp: ''!
from: aDistance 
	distanceFrom := aDistance! !

!DistanceInterval methodsFor: 'accessing' stamp: ''!
size
	^ (Interval
		from: (self from convertTo: MeasureUnit centimeter) amount
		to: (self to convertTo: MeasureUnit centimeter) amount
		by: (self by convertTo: MeasureUnit centimeter) amount) size! !

!DistanceInterval methodsFor: 'accessing' stamp: ''!
to
	^ distanceTo! !

!DistanceInterval methodsFor: 'accessing' stamp: ''!
to: aDistance 
	distanceTo := aDistance! !

Object subclass: #Measure
	instanceVariableNames: 'amount unit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!Measure class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 5/30/2012 20:51'!
of: anAmount in: aMeasureUnit 
	^ self new amount: anAmount;
		 unit: aMeasureUnit! !

!Measure methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/4/2012 23:11'!
* anObject 
	"esta incompleto el ifTrue: dominio complex mejorar si hay tiempo"
	| newMeasureUnit |
	
	(anObject isKindOf: Measure) ifTrue: [  |colDen1 colDen2 colNum1 colNum2 | 
											colNum1 := self unit numeradores.
											colNum2:= anObject unit numeradores.
											colNum1 addAll: colNum2.
											colDen1 := self unit denominadores.
									    		colDen2 := anObject unit denominadores.
											colDen1 addAll: colDen2.
											"sacar repetidos"
											
											newMeasureUnit := MeasureUnit new numeradores: colNum1;  denominadores:  colDen1; dominio: 'complex'; toBase: [:val | val]. 
      										^ Measure of: self amount * anObject amount in: newMeasureUnit]
	                                            ifFalse: [^ Measure of: self amount * anObject in: self unit]
	

! !

!Measure methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/3/2012 23:24'!
+ anotherMeasure 
	| normalizedSelf normalizedAnother |
	"falta agregar que chequee que son del mismo dominio, si no lo son, no deberia dejar sumar y daria error"
	
	normalizedSelf := self convertTo: self unit.
	normalizedAnother := anotherMeasure convertTo: self unit.

	^ Measure of: normalizedSelf amount + (normalizedAnother amount) in: self unit
	
	"
	normalizedSelf := self convertTo: MeasureUnit centimeter.
	normalizedOther := anotherMeasure convertTo: MeasureUnit centimeter.
	^ Measure of: normalizedSelf amount + normalizedOther amount / self unit ratio in: self unit
	
"! !

!Measure methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/3/2012 22:12'!
- anotherMeasure
	| normalizedSelf normalizedAnother |
	
	normalizedSelf := self convertTo: self unit.
	normalizedAnother := anotherMeasure convertTo: self unit.

	^ Measure of: normalizedSelf amount - (normalizedAnother amount) in: self unit

"	
	normalizedSelf := self convertTo: MeasureUnit centimeter.
	normalizedOther := anotherMeasure convertTo: MeasureUnit centimeter.
	^ Measure of: normalizedSelf amount - normalizedOther amount / self unit ratio in: self unit
	
"! !

!Measure methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/4/2012 23:43'!
/ anObject 
"	^ Measure of: self amount / anAmount in: self unit"
	"esta incompleto el ifTrue: dominio complex mejorar si hay tiempo"
	| newMeasureUnit |
	
	(anObject isKindOf: Measure) ifTrue: [  |colDen1 colDen2 colNum1 colNum2 copiaNumerador copiaDenominador| 
											
											colNum1 := self unit numeradores.
											colNum2:= anObject unit denominadores .
											colNum1 addAll: colNum2.
											"en colNum1 esta todo lo que va en el numerador del resultado"									
										 	copiaNumerador := colNum1 copy.
											
											colDen1 := self unit denominadores.
									    		colDen2 := anObject unit numeradores.
											colDen1 addAll: colDen2.
											"en colDen1 esta todo lo que va en el denominador del resultado"									
										 	copiaDenominador := colNum1 copy.
																									
											"sacar repeticiones del numerador y denominador"
											colNum1 do: [ :aNumerador | copiaDenominador remove: aNumerador ifAbsent: [nil].  ].
											colDen1 do: [ :aDenominador | copiaNumerador remove: aDenominador ifAbsent: [nil].  ].
											
"al simplificar podria no ser de dominio complex"											
newMeasureUnit := MeasureUnit new numeradores: copiaNumerador;  denominadores:  copiaDenominador; dominio: 'complex'; toBase: [:val | val]. 
((newMeasureUnit numeradores size = 0) and: (newMeasureUnit denominadores size = 0)) ifTrue: [^ self amount / anObject amount ] 
                                                                                                                                       ifFalse: [^ Measure of: self amount / anObject amount in: newMeasureUnit].
										 ]
	                                            ifFalse: [^ Measure of: self amount / anObject in: self unit]
	! !

!Measure methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/1/2012 00:07'!
< anotherMeasure 
	^ self amount < (anotherMeasure convertTo: self unit) amount! !

!Measure methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/1/2012 00:07'!
<= anotherMeasure
	^ self < anotherMeasure or: self = anotherMeasure! !

!Measure methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/3/2012 20:09'!
= anotherMeasure
	| retVal |
	retVal := false.
	(anotherMeasure isKindOf: Measure)
		ifTrue: [
			(self unit dominio = anotherMeasure unit dominio) ifTrue: [
																		| val1 val2 |
																		val1 := self unit toBase value: self amount.
																		val2 := anotherMeasure unit toBase value: anotherMeasure amount.
																		retVal := val1= val2. ]
			].
	^ retVal! !

!Measure methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/1/2012 00:08'!
> anotherMeasure
	^ anotherMeasure < self! !

!Measure methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/1/2012 00:08'!
>= anotherMeasure 
	^ self > anotherMeasure or: self = anotherMeasure! !

!Measure methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 5/30/2012 20:49'!
amount
	^ amount! !

!Measure methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 5/30/2012 20:49'!
amount: anAmount 
	amount := anAmount. ! !

!Measure methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/1/2012 00:09'!
between: aMeasure and: anotherMeasure 
	^ self <= anotherMeasure and: aMeasure <= self! !

!Measure methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/4/2012 22:11'!
convertTo: aMeasureUnit 
	"^ Measure of: self amount * self unit ratio / aMeasureUnit ratio in: aMeasureUnit"
	
	| convertedAmount |
	
	(self unit dominio = aMeasureUnit dominio) ifFalse: [^ MeasureConverterException signal: 'No se puede convertir la medida a la unidad pedida'].

	convertedAmount := aMeasureUnit fromBase value: (self unit toBase value: self amount).
	
	^ Measure of: convertedAmount in: aMeasureUnit
	 
"	  amountConverted := self unit ratio value: self amount.
	  dividirpor := aMeasureUnit ratio value: 1.
"	
	
	
	
	
! !

!Measure methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 5/30/2012 19:48'!
hash
	^ self! !

!Measure methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/2/2012 12:15'!
isTiempo
	"comment stating purpose of message"

	| temporary variable names |
	^ false! !

!Measure methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/1/2012 00:09'!
max: anotherMeasure
	self > anotherMeasure
		ifTrue: [^ self].
	^ anotherMeasure! !

!Measure methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/1/2012 00:10'!
min: anotherMeasure
	self < anotherMeasure
		ifTrue: [^ self].
	^ anotherMeasure! !

!Measure methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/4/2012 20:34'!
negated

	^self * -1! !

!Measure methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 5/30/2012 19:48'!
printOn: aStream 
	aStream nextPutAll: self amount printString.
	aStream nextPutAll: ' '.
	aStream nextPutAll: self unit printString.
	self amount abs > 1
		ifTrue: [aStream nextPutAll: 's']! !

!Measure methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/1/2012 00:11'!
to: anotherMeasure
	^ self
		to: anotherMeasure
		by: (Measure of: 1 in: self unit)! !

!Measure methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/1/2012 00:11'!
to: anotherMeasure by: aStepMeasure 
	^ DistanceInterval
		from: self
		to: anotherMeasure
		by: aStepMeasure! !

!Measure methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 5/30/2012 21:07'!
unit
	^ unit! !

!Measure methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 5/30/2012 21:08'!
unit: aMeasureUnit 
	unit := aMeasureUnit! !

Object subclass: #MeasureUnit
	instanceVariableNames: 'unitName dominio fromBase toBase colDenominadores colNumeradores'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!MeasureUnit class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/3/2012 23:46'!
celsius

	^ MeasureUnit new 
		unitName: 'celsius'; 
		dominio:'temperature'; 
		fromBase: [:cel | cel]; 
		toBase: [:cel | cel]; 
		numeradores: nil;
		denominadores: nil
		! !

!MeasureUnit class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/3/2012 23:46'!
centimeter
	^ self new 
		unitName: 'centimeter'; 
		dominio:'distance'; 
		fromBase: [:cent | cent]; 
		toBase: [:cent | cent];
		numeradores: nil;
		denominadores: nil
! !

!MeasureUnit class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/4/2012 02:04'!
cubicMeter

	| col |
	col := OrderedCollection new.
	col add: 'meter'.
	col add: 'meter'.
	col add: 'meter'.
	
	^ MeasureUnit new 
		unitName: 'meter * meter * meter';     "meter * meter * meter "
		dominio:'complex'; 
		fromBase: [ :val | val]; 
		toBase: [:val | val];
		numeradores: col; 
		denominadores: OrderedCollection new
		! !

!MeasureUnit class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/3/2012 23:46'!
day

	^ self new 
		unitName: 'day'; 
		dominio:'time'; 
		fromBase: [:sec | sec / 86400]; 
		toBase: [:day | day * 86400];
		numeradores: nil;
		denominadores: nil
! !

!MeasureUnit class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/3/2012 23:46'!
decameter
	^ self new 
		unitName: 'decameter'; 
		dominio:'distance'; 
		fromBase: [:cent | cent / 1000]; 
		toBase: [:dec | dec * 1000];
		numeradores: nil;
		denominadores: nil

! !

!MeasureUnit class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/3/2012 23:46'!
decimeter
	^ self new 
		unitName: 'decimeter'; 
		dominio:'distance'; 
		fromBase: [:cent | cent / 10]; 
		toBase: [:dec | dec * 10];
		numeradores: nil;
		denominadores: nil! !

!MeasureUnit class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/3/2012 23:46'!
fahrenheit

	^ self new
		 unitName: 'fahrenheit';
		 dominio: 'temperature';
             fromBase: [:cel | cel * 9 / 5 + 32];
		 toBase: [:fah | (fah - 32) / 1.8 ];
		numeradores: nil;
		denominadores: nil
! !

!MeasureUnit class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/4/2012 22:04'!
hectometer
	^ self new 
		unitName: 'hectometer'; 
		dominio:'distance'; 
		fromBase: [:cent | cent / 10000]; 
		toBase: [:hect | hect * 10000];
		numeradores: nil;
		denominadores: nil
! !

!MeasureUnit class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/3/2012 23:47'!
hour

	^ self new 
		unitName: 'hour'; 
		dominio:'time'; 
		fromBase: [:sec | sec / 3600]; 
		toBase: [:hour | hour * 3600];
		numeradores: nil;
		denominadores: nil

! !

!MeasureUnit class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/3/2012 23:47'!
kelvin

	^ self new 
		 unitName: 'kelvin';
		 dominio: 'temperature';
		 toBase: [:kel | kel + 273.15];
		 fromBase: [:cel | cel - 273.15];
		numeradores: nil;
		denominadores: nil
! !

!MeasureUnit class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/3/2012 23:47'!
kilometer
	^ self new 
		unitName: 'kilometer'; 
		dominio:'distance'; 
		fromBase: [:cent | cent / 100000]; 
		toBase: [:kil | kil * 100000];
		numeradores: nil;
		denominadores: nil

! !

!MeasureUnit class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/4/2012 02:03'!
meter
	| col |
	col := OrderedCollection new.
	col add: 'meter'.

	^ self new 
		unitName: 'meter'; 
		dominio:'distance'; 
		fromBase: [:cent | cent / 100]; 
		toBase: [:met | met * 100];
		numeradores: col;
		denominadores: OrderedCollection new

! !

!MeasureUnit class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/4/2012 02:55'!
meterBySecond

	| colNumerador colDenominador |
	colNumerador := OrderedCollection new.
	colNumerador add: 'meter'.
	
	colDenominador := OrderedCollection new.
	colDenominador add: 'second'.

	^ MeasureUnit new 
		unitName: 'meter / second';     
		dominio:'complex'; 
		fromBase: [ :val | val]; 
		toBase: [:val | val];
		numeradores: colNumerador; 
		denominadores: colDenominador
		! !

!MeasureUnit class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/4/2012 11:26'!
meterBySquaredSecond

	| col col2 |
	col := OrderedCollection new.
	col add: 'meter'.

	col2 := OrderedCollection new.
	col2 add: 'second'.
	col2 add: 'second'.
	

	^ MeasureUnit new 
		unitName: 'second * second';     
		dominio:'complex'; 
		fromBase: [ :val | val]; 
		toBase: [:val | val];
		numeradores: col; 
		denominadores: col2
		! !

!MeasureUnit class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/4/2012 02:10'!
meterPerSecond

	| col |
	col := OrderedCollection new.
	col add: 'meter'.
	col add: 'second'.
	

	^ MeasureUnit new 
		unitName: 'meter * second';     
		dominio:'complex'; 
		fromBase: [ :val | val]; 
		toBase: [:val | val];
		numeradores: col; 
		denominadores: OrderedCollection new
		! !

!MeasureUnit class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/4/2012 02:04'!
millimeter

	| col |
	col := OrderedCollection new.
	col add: 'milimeter'.

	
	^ self new 
		unitName: 'milimeter'; 
		dominio:'distance'; 
		fromBase: [:cent | cent * 10]; 
		toBase: [:mil | mil / 10];
		numeradores: col;
		denominadores: OrderedCollection new

! !

!MeasureUnit class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/4/2012 02:03'!
minute
| col |
	col := OrderedCollection new.
	col add: 'minute'.


	^ self new 
		unitName: 'minute'; 
		dominio:'time'; 
		fromBase: [:sec | sec / 60]; 
		toBase: [:min | min * 60];
		numeradores: col;
		denominadores: OrderedCollection new
! !

!MeasureUnit class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/4/2012 02:02'!
second

	| col |
	col := OrderedCollection new.
	col add: 'second'.

	
	^ self new 
		unitName: 'second'; 
		dominio:'time'; 
		fromBase: [:sec | sec]; 
		toBase: [:sec | sec] ;
		numeradores: col;
		denominadores: (OrderedCollection new)
! !

!MeasureUnit class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/4/2012 01:56'!
squaredMeter
	| col |
	col := OrderedCollection new.
	col add: 'meter'.
	col add: 'meter'.
	
	^ MeasureUnit new 
		unitName: 'meter * meter';     "meter * meter'; "
		dominio:'complex'; 
		fromBase: [ :val | val]; 
		toBase: [:val | val];
		numeradores: col; 
		denominadores: OrderedCollection new
		! !

!MeasureUnit class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/4/2012 02:01'!
squaredSecond

	| col |
	col := OrderedCollection new.
	col add: 'second'.
	col add: 'second'.
	

	^ MeasureUnit new 
		unitName: 'second * second';     
		dominio:'complex'; 
		fromBase: [ :val | val]; 
		toBase: [:val | val];
		numeradores: col; 
		denominadores: OrderedCollection new
		! !

!MeasureUnit methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/2/2012 13:29'!
= anotherUnit 
	^ self unitName = anotherUnit unitName! !

!MeasureUnit methodsFor: 'accessing' stamp: 'BarroumeresLaje 6/3/2012 23:15'!
denominadores
	^ colDenominadores! !

!MeasureUnit methodsFor: 'accessing' stamp: 'BarroumeresLaje 6/3/2012 23:45'!
denominadores: aCol
	colDenominadores := aCol.! !

!MeasureUnit methodsFor: 'accessing' stamp: 'BarroumeresLaje 6/2/2012 12:20'!
dominio
	^ dominio! !

!MeasureUnit methodsFor: 'accessing' stamp: 'BarroumeresLaje 6/2/2012 12:21'!
dominio: aDomain
	dominio := aDomain.! !

!MeasureUnit methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/3/2012 19:10'!
fromBase
	"comment stating purpose of message"

	| temporary variable names |
	^ fromBase! !

!MeasureUnit methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/3/2012 19:10'!
fromBase: aBlock
	"comment stating purpose of message"

	| temporary variable names |
	fromBase := aBlock.! !

!MeasureUnit methodsFor: 'accessing' stamp: 'BarroumeresLaje 6/3/2012 23:14'!
numeradores
	^ colNumeradores! !

!MeasureUnit methodsFor: 'accessing' stamp: 'BarroumeresLaje 6/3/2012 23:45'!
numeradores: aCol
	colNumeradores := aCol.! !

!MeasureUnit methodsFor: 'as yet unclassified' stamp: ''!
printOn: aStream 
	aStream nextPutAll: self unitName! !

!MeasureUnit methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/3/2012 19:10'!
toBase
	"comment stating purpose of message"

	| temporary variable names |
	^ toBase! !

!MeasureUnit methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/3/2012 19:09'!
toBase: aBlock
	"comment stating purpose of message"

	| temporary variable names |
	toBase := aBlock.! !

!MeasureUnit methodsFor: 'accessing' stamp: ''!
unitName
	^ unitName! !

!MeasureUnit methodsFor: 'accessing' stamp: ''!
unitName: anObject 
	unitName := anObject! !

TestCase subclass: #MeasureTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!MeasureTest methodsFor: 'errors' stamp: 'BarroumeresLaje 6/4/2012 22:49'!
canNotConvertMeasurementException
	
	"self error: 'Este metodo debe devolver el objeto que representa que no se pudo
		convertir una medida a la unidad pedida'"
	^ MeasureConverterException	
		"signal: 'No se puede convertir la medida a la unidad pedida'"
		
"Notification signal: 'No se puede convertir la medida a la unidad pedida"! !

!MeasureTest methodsFor: 'temperature units' stamp: 'BarroumeresLaje 5/30/2012 20:58'!
celsius
	
		^MeasureUnit celsius  ! !

!MeasureTest methodsFor: 'distance units' stamp: 'BarroumeresLaje 5/30/2012 18:52'!
centimeter
	
	^MeasureUnit centimeter 
	! !

!MeasureTest methodsFor: 'time units' stamp: 'BarroumeresLaje 5/30/2012 21:01'!
day
	
	^MeasureUnit day ! !

!MeasureTest methodsFor: 'distance units' stamp: 'BarroumeresLaje 5/30/2012 18:52'!
decameter
	
	^MeasureUnit decameter.! !

!MeasureTest methodsFor: 'distance units' stamp: 'BarroumeresLaje 5/30/2012 18:52'!
decimeter
	
	^MeasureUnit decimeter! !

!MeasureTest methodsFor: 'distance measures' stamp: 'HernanWilkinson 4/25/2011 17:27'!
distanceExamples 

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'distance units' stamp: 'HernanWilkinson 4/25/2011 17:27'!
distanceUnits 

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'compound measures' stamp: 'BarroumeresLaje 6/4/2012 01:49'!
eightCubicMeters

	^Measure of: 8 in: MeasureUnit cubicMeter ! !

!MeasureTest methodsFor: 'temperature units' stamp: 'BarroumeresLaje 5/30/2012 21:04'!
fahrenheit
	
			^MeasureUnit fahrenheit  ! !

!MeasureTest methodsFor: 'compound measures' stamp: 'BarroumeresLaje 6/4/2012 11:29'!
finalSpeedStartingAt: initialSpeed accelerating: anAcceleration during: aTimePeriod

"	^self error: 'Implementar la formula de velocidad final: vf = vi + a * t'"
	
	^ initialSpeed + (anAcceleration * aTimePeriod)! !

!MeasureTest methodsFor: 'compound measures' stamp: 'BarroumeresLaje 6/4/2012 01:49'!
fourSquaredMeters

	^Measure of: 4 in: MeasureUnit squaredMeter ! !

!MeasureTest methodsFor: 'distance units' stamp: 'BarroumeresLaje 5/30/2012 18:54'!
hectometer
	
	^MeasureUnit hectometer! !

!MeasureTest methodsFor: 'time units' stamp: 'BarroumeresLaje 5/30/2012 21:05'!
hour
	
	^MeasureUnit hour.! !

!MeasureTest methodsFor: 'temperature units' stamp: 'BarroumeresLaje 5/30/2012 21:05'!
kelvin
	
	^MeasureUnit kelvin.! !

!MeasureTest methodsFor: 'distance units' stamp: 'BarroumeresLaje 5/30/2012 18:54'!
kilometer
	
 ^MeasureUnit kilometer ! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:30'!
measureExamples 

	^ OrderedCollection new
		addAll: self distanceExamples;
		addAll: self temperatureExamples;
		addAll: self timeExamples;
		yourself ! !

!MeasureTest methodsFor: 'distance units' stamp: 'BarroumeresLaje 5/30/2012 18:55'!
meter

	^MeasureUnit meter! !

!MeasureTest methodsFor: 'distance units' stamp: 'BarroumeresLaje 5/30/2012 18:55'!
millimeter
	
	^MeasureUnit millimeter ! !

!MeasureTest methodsFor: 'distance measures' stamp: 'BarroumeresLaje 5/30/2012 21:18'!
minusOneMeter 
	
	^Measure of:  -1  in: MeasureUnit meter.! !

!MeasureTest methodsFor: 'time units' stamp: 'BarroumeresLaje 5/30/2012 21:05'!
minute
	
	^MeasureUnit minute.! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:27'!
objectsInCategoryOf: aSelector

	| category messageNames |
	
	category := self class organization categoryOfElement: aSelector.
	messageNames := (self class organization listAtCategoryNamed:  category) reject: [ :aMessageName | aMessageName = aSelector ].
	
	 ^ messageNames collect: [ :aMessageName | self perform: aMessageName ]
	

	
! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'BarroumeresLaje 5/30/2012 20:53'!
oneCelsius
	
	^Measure of: 1 in: MeasureUnit celsius ! !

!MeasureTest methodsFor: 'distance measures' stamp: 'BarroumeresLaje 5/30/2012 21:18'!
oneCentimeter
	
	^Measure of: 1 in: MeasureUnit centimeter ! !

!MeasureTest methodsFor: 'time measures' stamp: 'BarroumeresLaje 6/2/2012 14:11'!
oneDay
	
		^Measure of: 1 in: MeasureUnit day! !

!MeasureTest methodsFor: 'time measures' stamp: 'BarroumeresLaje 6/2/2012 14:11'!
oneHour
	
		^Measure of: 1 in: MeasureUnit hour! !

!MeasureTest methodsFor: 'distance measures' stamp: 'BarroumeresLaje 5/30/2012 21:18'!
oneHundredCentimeters
	
	^Measure of: 100 in: MeasureUnit centimeter ! !

!MeasureTest methodsFor: 'compound measures' stamp: 'BarroumeresLaje 6/5/2012 00:23'!
oneHundredTwentyOneMetersPerSecond

	"^self error: 'este metodo debe devolver la medida 121 metro/segundo'"
	
	^Measure of: 121 in: MeasureUnit meterBySecond ! !

!MeasureTest methodsFor: 'distance measures' stamp: 'BarroumeresLaje 5/30/2012 20:51'!
oneMeter
	
	^Measure of: 1 in: MeasureUnit meter! !

!MeasureTest methodsFor: 'compound measures' stamp: 'BarroumeresLaje 6/4/2012 11:28'!
oneMeterPerSecond


	^Measure of: 1 in: MeasureUnit meterBySecond ! !

!MeasureTest methodsFor: 'time measures' stamp: 'BarroumeresLaje 5/30/2012 21:10'!
oneMinute
	
		^Measure of: 1 in: MeasureUnit minute! !

!MeasureTest methodsFor: 'time measures' stamp: 'BarroumeresLaje 5/30/2012 20:52'!
oneSecond

	^Measure of: 1 in: MeasureUnit second! !

!MeasureTest methodsFor: 'compound measures' stamp: 'BarroumeresLaje 6/3/2012 23:56'!
oneSquaredMeter

"	^self error: 'este metodo debe devolver la medida 1 metro cuadrado'"
	^Measure of: 1 in: MeasureUnit squaredMeter ! !

!MeasureTest methodsFor: 'compound measures' stamp: 'BarroumeresLaje 6/4/2012 01:48'!
oneSquaredSecond

	^Measure of: 1 in: MeasureUnit squaredSecond ! !

!MeasureTest methodsFor: 'time units' stamp: 'BarroumeresLaje 5/30/2012 21:06'!
second
	
	^MeasureUnit second.! !

!MeasureTest methodsFor: 'time measures' stamp: 'BarroumeresLaje 6/2/2012 14:14'!
sixtyMinutes
	
		^Measure of: 60 in: MeasureUnit minute! !

!MeasureTest methodsFor: 'time measures' stamp: 'BarroumeresLaje 6/2/2012 14:14'!
sixtyOneSeconds
	
		^Measure of: 61 in: MeasureUnit second! !

!MeasureTest methodsFor: 'time measures' stamp: 'BarroumeresLaje 5/30/2012 21:09'!
sixtySeconds
	
		^Measure of: 60 in: MeasureUnit second! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'HernanWilkinson 4/25/2011 17:28'!
temperatureExamples

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'temperature units' stamp: 'HernanWilkinson 4/25/2011 17:28'!
temperatureUnits

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:05'!
test01ObjectsRepresentingSameMeasureShouldBeEqual

	self assert: self oneMeter = self oneMeter.
	self assert: self oneSecond = self oneSecond.
	self assert: self oneCelsius = self oneCelsius.
	

! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:06'!
test02DifferentMeasuresShouldNotBeEqual

	self deny: self oneMeter = self twoMeters.
	self deny: self oneSecond = self sixtySeconds.
	self deny: self oneCelsius = self zeroCelsius.
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:07'!
test03SameMeasureExpressWithDifferentUnitsShouldBeEqual

	self assert: self oneMeter = self oneHundredCentimeters.
	self assert: self twoMeters = self twoHundredCentimeters.
	self assert: self oneMinute = self sixtySeconds.
	self assert: self zeroCelsius = self thirtyTwoFahrenheits.
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:08'!
test03aMeasuresOfDifferentDomainShouldNotBeEqual

	self deny: self oneMeter = self oneSecond.
	self deny: self oneMeter = self oneCelsius.
	self deny: self oneCelsius = self oneSecond
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:09'!
test04EqualsShouldBeCommutative

	self assert: (self oneMeter = self oneHundredCentimeters and: [ self oneHundredCentimeters = self oneMeter ]).
	self assert: (self twoMeters = self twoHundredCentimeters and:  [ self twoHundredCentimeters = self twoMeters ]).
	self assert: (self oneMinute = self sixtySeconds and: [self sixtySeconds = self oneMinute]).
	self assert: (self zeroCelsius = self thirtyTwoFahrenheits and: [ self thirtyTwoFahrenheits = self zeroCelsius]).
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:11'!
test05UnitStringRepresentationShouldBeHumanReadable

	self assert: self meter printString = 'meter'.
	self assert: self centimeter printString = 'centimeter'.
	self assert: self decimeter printString = 'decimeter'.
	self assert: self millimeter printString = 'milimeter'.
	self assert: self decameter printString = 'decameter'.
	self assert: self hectometer printString = 'hectometer'.
	self assert: self kilometer printString = 'kilometer'.	
	
	self assert: self celsius printString = 'celsius'.	
	self assert: self fahrenheit printString = 'fahrenheit'.	

	self assert: self day printString = 'day'.	
	self assert: self hour printString = 'hour'.	
	self assert: self minute printString = 'minute'.	
	self assert: self second printString = 'second'.	

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'BarroumeresLaje 6/2/2012 14:16'!
test06MeasureStringRepresentationShouldBeHumanReadable

	self assert: self oneMeter printString = '1 meter'.
	self assert: self twoMeters printString = '2 meters'.
	self assert: self oneHundredCentimeters printString = '100 centimeters'.
	
	self assert: self oneMinute printString = '1 minute'.
	self assert: self sixtySeconds printString = '60 seconds'.
	
	self assert: self zeroCelsius printString = '0 celsius'.
	self assert: self thirtyTwoFahrenheits printString = '32 fahrenheits'.
	
	
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:14'!
test07aMeasureAmountShouldBeTheExpectedAmount

	self assert: self oneMeter amount = 1.
	self assert: self twoMeters amount = 2.
	self assert: self oneHundredCentimeters amount = 100.
	self assert: self twoHundredCentimeters amount = 200.

	self assert: self oneMinute amount = 1.
	self assert: self sixtySeconds amount = 60.
	
	self assert: self zeroCelsius amount = 0.
	self assert: self thirtyTwoFahrenheits amount = 32.
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:15'!
test07bMeasureUnitShouldBeTheExpectedUnit

	self assert: self oneMeter unit = self meter.
	self assert: self twoMeters unit = self meter.
	self assert: self oneHundredCentimeters unit = self centimeter.
	self assert: self twoHundredCentimeters unit = self centimeter.
	
	self assert: self oneMinute unit = self minute.
	self assert: self sixtySeconds unit = self second.
	
	self assert: self zeroCelsius unit = self celsius.
	self assert: self thirtyTwoFahrenheits unit = self fahrenheit
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:15'!
test07cDifferentMeasureUnitsShouldBeDifferent

	| unitsGroupedByItself |
	
	unitsGroupedByItself := self units groupedBy: [ :aUnit | aUnit ].
	self assert: (unitsGroupedByItself allSatisfy: [:aCollectionOfUnit | aCollectionOfUnit size = 1] )
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:03'!
test07dDistancesCanBeConvertedToDifferentUnits

	"A partir de los test de igualdad, se deben haber dado cuenta que debemos poder
	convertir distancias a distintas unidades... y que ademas dos distancias de distintas unidades
	pueden ser iguales... Por lo tanto por qu no hacer esta caracteristica de las distancias explicita?
	Veran que luego se torna muy util
	
	Respecto de como esta escrito el test, para no tener que escribir los assert para oneMeter y oneHundredCentimeters 
	creo un array y lo recorro... Se podria escribir menos aun en este test?
	
	Y por qu se asserta sobre el amount y luego la unidad y no directametne sobre la distancia completa. ej:
	self assert: (aDistance converTo: self meter) = self oneMeter
	"
	
	(Array with: self oneMeter with: self oneHundredCentimeters) do: [ :aDistance |
		self assert: (aDistance convertTo: self meter) amount = 1.
		self assert: (aDistance convertTo: self meter) unit = self meter.
		
		self assert: (aDistance convertTo: self decimeter) amount = 10.
		self assert: (aDistance convertTo: self decimeter) unit = self decimeter.
		
		self assert: (aDistance convertTo: self centimeter) amount = 100.
		self assert: (aDistance convertTo: self centimeter) unit = self centimeter.
		
		self assert: (aDistance convertTo: self millimeter) amount = 1000.
		self assert: (aDistance convertTo: self millimeter) unit = self millimeter.
	
		self assert: (aDistance convertTo: self decameter) amount = (1/10).
		self assert: (aDistance convertTo: self decameter) unit = self decameter.
		
		self assert: (aDistance convertTo: self hectometer) amount = (1/100).
		self assert: (aDistance convertTo: self hectometer) unit = self hectometer.
	
		self assert: (aDistance convertTo: self kilometer) amount = (1/1000).
		self assert: (aDistance convertTo: self kilometer) unit = self kilometer ]! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:17'!
test07eTimeMeasuresCanBeConvertedToDifferentUnits

	self assert: (self oneMinute convertTo: self second) = self sixtySeconds.
	self assert: (self sixtySeconds convertTo: self minute) = self oneMinute.

	self assert: (self oneHour convertTo: self minute) = self sixtyMinutes.
	self assert: (self sixtyMinutes convertTo: self hour) = self oneHour.

	self assert: (self oneDay convertTo: self hour) = self twentyFourHours.
	self assert: (self twentyFourHours convertTo: self day) = self oneDay.

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:17'!
test07fTemperatureMeasuresCanBeConvertedToDifferentUnits

	self assert: (self zeroCelsius convertTo: self fahrenheit) = self thirtyTwoFahrenheits.
	self assert: (self thirtyTwoFahrenheits convertTo: self celsius) = self zeroCelsius.

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:19'!
test07gMeasuresCanNotBeConvertedToUnitsOfDifferentDomain

	self should: [ self oneMeter convertTo: self second ] raise: self canNotConvertMeasurementException.
	self should: [ self oneSecond convertTo: self celsius ] raise: self canNotConvertMeasurementException.
	self should: [ self oneCelsius convertTo: self centimeter ] raise: self canNotConvertMeasurementException.


! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:20'!
test08aComparingMeasuresWithOtherObjectsShouldReturnFalse

	"El igual no debe generar ningun tipo de error por mas que se comparen objetos
	de distintos tipos
	Fijense como se crea una instancia de Object sin ningun tipo de problema... qu representa?"

	self deny: self oneMeter = Object new.
	self deny: Object new = self oneMeter! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:21'!
test08bMeasuresThatAreEqualShouldReturnTheSameHash

	"Debido a como funcionan los diccionarios, cuando dos objetos son iguales deben
	tener es mismo hash. La inversa no es verdad"
	
	self assert: self oneMeter hash=self oneMeter hash.
	self assert: self oneMeter hash=self oneHundredCentimeters hash.
	self assert: self oneMinute hash = self sixtySeconds hash.
	self assert: self zeroCelsius hash = self thirtyTwoFahrenheits hash.
	
	
! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:21'!
test08cCopiesOfTheSameMeasureShouldBeEqual

	"Dos objetos que ocupan distintas posiciones de memoria pero representan
	la misma entidad de la realidad, deben devolver true cuando se los compara por igual, puesto
	que representan la misma entidad de la realidad.
	Por lo tanto, el mensaje #= significa 'representan el mismo ente de la realidad?'
	mientras que el mensaje #== significa ocupan la misma posicion de memoria?"

	| originalOneMeter copiedOneMeter |

	"Al objeto oneMeter lo copio para asegurarme de tener uno oneMeter en otra posicion de memoria"

	originalOneMeter := self oneMeter.
	copiedOneMeter := originalOneMeter copy.

	"Me aseguro que ocupen distinta posicion de memoria"
	self deny: originalOneMeter == copiedOneMeter.

	"Ahora me aseguro que sean iguales"
	self assert: originalOneMeter = copiedOneMeter! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:31'!
test09AddingMeasuresOfSameUnitShouldReturnAMeasureRepresentingTheAddingMeasures

	self assert: (self oneMeter + self oneMeter) = self twoMeters.
	self assert: (self oneSecond + self oneSecond) = self twoSeconds.
	self assert: (self oneCelsius + self oneCelsius) = self twoCelsius.
	

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:32'!
test10AddingMeasuresOfDifferentUnitShouldReturnAMeasureRepresentingTheAddingMeasures

	self assert: (self oneMeter + self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneMeter + self oneHundredCentimeters) = self twoHundredCentimeters.
	self assert: (self oneSecond + self oneMinute) = self sixtyOneSeconds.

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:48'!
test10aCanNotAddMeasuresOfDifferentDomain

	self should: [ self oneMeter + self oneSecond ] raise: self canNotConvertMeasurementException 

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:32'!
test11AddingMeasuresIsCommutative

	self assert: (self oneMeter + self twoMeters)=(self twoMeters + self oneMeter).
	self assert: (self oneSecond + self twoSeconds)=(self twoSeconds + self oneSecond).
	self assert: (self oneCelsius + self twoCelsius)=(self twoCelsius + self oneCelsius)
	


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:33'!
test12AddingMeasuresIsAssociative

	self assert: 
		((self oneMeter + self oneMeter) + self twoMeters) = 
		(self oneMeter + (self oneMeter + self twoMeters)).

	self assert: 
		((self oneSecond + self oneSecond) + self twoSeconds) = 
		(self oneSecond + (self oneSecond + self twoSeconds)).

	self assert: 
		((self oneCelsius + self oneCelsius) + self twoCelsius) = 
		(self oneCelsius + (self oneCelsius + self twoCelsius)).

		

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:35'!
test12aAddingMeasuresKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter + oneMeter.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond + oneSecond.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius + oneCelsius.
	
	self assert: oneCelsius = self oneCelsius 



! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'BarroumeresLaje 6/4/2012 20:22'!
test13aNegatingAMeasureNegatesItsAmount

	(Array with: self oneMeter with: self twoSeconds with: self thirtyTwoFahrenheits) do: [:aMeasure | self assert: aMeasure negated amount=aMeasure amount negated ]
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:36'!
test13bNegatingAMeasureIsReflective

	(Array with: self oneMeter with: self twoSeconds with: self thirtyTwoFahrenheits) do: [:aMeasure |
		self assert: aMeasure negated negated=aMeasure ].
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:37'!
test14SubtractingMeasuresOfSameUnitShouldReturnAMeasureRepresentingTheSubtractedMeasures

	self assert: (self twoMeters - self oneMeter) = self oneMeter.
	self assert: (self oneMeter - self oneMeter) = self zeroMeters.
	self assert: (self oneMeter - self twoMeters) = self oneMeter negated.
	
	self assert: (self twoSeconds - self oneSecond) = self oneSecond.
	self assert: (self oneSecond - self oneSecond) = self zeroSeconds.
	self assert: (self oneSecond - self twoSeconds) = self oneSecond negated.
	
	self assert: (self twoCelsius - self oneCelsius) = self oneCelsius.
	self assert: (self oneCelsius - self oneCelsius) = self zeroCelsius.
	self assert: (self oneCelsius - self twoCelsius) = self oneCelsius negated.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:38'!
test15SubtractingMeasuresOfDifferentUnitShouldReturnAMeasureRepresentingTheSubtractedMeasures

	self assert: (self twoMeters - self oneHundredCentimeters) = self oneMeter.
	self assert: (self oneMeter - self oneHundredCentimeters) = self zeroMeters.
	self assert: (self oneHundredCentimeters - self twoMeters) = self oneMeter negated.
	
	self assert: (self sixtyOneSeconds - self oneMinute) = self oneSecond.
	

	! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:48'!
test15aCanNotSubtractMeasuresOfDifferentDomain

	self should: [ self oneMeter - self oneSecond ] raise: self canNotConvertMeasurementException 

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:38'!
test16SubtractingMeasuresIsAssociative

	self assert: 
		((self twoMeters - self oneMeter) - self oneMeter) = 
		(self twoMeters - (self oneMeter + self oneMeter)).

	self assert: 
		((self twoSeconds - self oneSecond) - self oneSecond) = 
		(self twoSeconds - (self oneSecond + self oneSecond)).	

	

	! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:39'!
test16aSubtractingMeasuresKeepsMeasuresImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter - oneMeter.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond - oneSecond.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius - oneCelsius.
	
	self assert: oneCelsius = self oneCelsius 


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:40'!
test17aMeasuresCanBeMultiplyByAnInteger

	self assert: self oneMeter * 1 = self oneMeter.
	self assert: self oneMeter * 2 = self twoMeters.
	self assert: self oneMeter * 0 = self zeroMeters.

	self assert: self oneSecond * 1 = self oneSecond.
	self assert: self oneSecond * 2 = self twoSeconds.
	self assert: self oneSecond * 0 = self zeroSeconds.

	self assert: self oneCelsius * 1 = self oneCelsius.
	self assert: self oneCelsius * 2 = self twoCelsius.
	self assert: self oneCelsius * 0 = self zeroCelsius.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:40'!
test17bMeasuresCanBeMultiplyByAFraction

	self assert: (self oneMeter * (2/3)) amount = (2/3).
	self assert: (self twoMeters * (2/3)) amount = (2 * (2/3)).

	self assert: (self oneSecond * (2/3)) amount = (2/3).
	self assert: (self twoSeconds * (2/3)) amount = (2 * (2/3)).

	self assert: (self oneCelsius * (2/3)) amount = (2/3).
	self assert: (self twoCelsius * (2/3)) amount = (2 * (2/3)).
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:41'!
test17cMeasuresCanBeMultiplyByAFloat

	self assert: (self oneMeter * 2.5) amount = 2.5.
	self assert: (self twoMeters * 2.5) amount = (2 * 2.5).

	self assert: (self oneSecond * 2.5) amount = 2.5.
	self assert: (self twoSeconds * 2.5) amount = (2 * 2.5).

	self assert: (self oneCelsius * 2.5) amount = 2.5.
	self assert: (self twoCelsius * 2.5) amount = (2 * 2.5).
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:45'!
test17dMeasuresCanBeMultiplyByAMeasureOfSameDomain

	self assert: (self oneMeter * self oneMeter) = self oneSquaredMeter.
	self assert: (self twoMeters * self twoMeters) = self fourSquaredMeters.
	self assert: (self twoMeters * self twoMeters * self twoMeters) = self eightCubicMeters.

	self assert: (self oneSecond * self oneSecond) = self oneSquaredSecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:53'!
test17eMeasuresCanBeMultiplyByAMeasureOfDifferentDomain

	self assert: (self oneMeter * self twoSeconds) = self twoMetersTimesSecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:42'!
test18MultiplicationKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter * 2.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond * 2.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius * 2.
	
	self assert: oneCelsius = self oneCelsius 




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:49'!
test19aMeasuresCanBeDividedByAnInteger

	self assert: (self oneMeter / 1) = self oneMeter.
	self assert: (self twoMeters / 2) = self oneMeter.

	self assert: (self oneSecond / 1) = self oneSecond.
	self assert: (self twoSeconds / 2) = self oneSecond.

	self assert: (self oneCelsius / 1) = self oneCelsius.
	self assert: (self twoCelsius / 2) = self oneCelsius.

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:50'!
test19bMeasuresCanBeDividedByAFraction

	self assert: (self twoMeters / (1/3)) amount = 6.
	self assert: (self twoSeconds / (1/3)) amount = 6.
	self assert: (self twoCelsius / (1/3)) amount = 6.




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:50'!
test19cMeasuresCanBeDividedByAFloat

	self assert: (self twoMeters / 2.5) amount = (2/2.5).
	self assert: (self twoSeconds / 2.5) amount = (2/2.5).
	self assert: (self twoCelsius / 2.5) amount = (2/2.5).




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:52'!
test19dMeasuresCanBeDividedByAMeasureOfSameDomain

	self assert: (self oneMeter / self oneMeter) = 1.
	self assert: (self twoMeters / self oneMeter) = 2.
		
	self assert: (self oneSecond / self oneSecond) = 1.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'BarroumeresLaje 6/4/2012 23:45'!
test19eMeasuresCanBeDividedByAMeasureOfDifferentDomain

	self assert: (self twoMeters / self oneSecond) = self twoMetersBySecond.

"	self assert: (self oneMeter / self twoSeconds) = self twoMetersBySecond."
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:54'!
test20DivisionKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter / 2.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond / 2.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius / 2.
	
	self assert: oneCelsius = self oneCelsius 


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'BarroumeresLaje 6/5/2012 00:23'!
test20aFinalSpeedCanBeRepresentedWithMeasures

	self assert: 
		(self finalSpeedStartingAt: self oneMeterPerSecond accelerating: self twoMetersPerSquaredSecond during: self sixtySeconds) = 
		(self oneMeterPerSecond + (self twoMetersPerSquaredSecond * self sixtySeconds)).
		
	self assert: (self finalSpeedStartingAt: self oneMeterPerSecond accelerating: self twoMetersPerSquaredSecond during: self sixtySeconds) = self oneHundredTwentyOneMetersPerSecond 
	
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 17:00'!
test20bMultiplyingANumberByAUnitReturnsAMeasure

	self assert: (1*self meter) = self oneMeter.
	self assert: (2*self second) = self twoSeconds.
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:02'!
test21MeasuresProvideATotalOrder

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure < (aMeasure + (1* aMeasure unit))])

! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:03'!
test22MeasuresCanBeComparedWithGreaterThan

	self assert: (self measureExamples allSatisfy: [ :aMeasure | (aMeasure + (1 * aMeasure unit)) > aMeasure ])
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:04'!
test23MeasuresCanBeComparedWithLessThanOrEqual

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure <= aMeasure and: [aMeasure <= (aMeasure + (1 * aMeasure unit))]])

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test24MeasuresCanBeComparedWithGreaterThanOrEqual

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure >= aMeasure and: [(aMeasure + (1 * aMeasure unit)) >= aMeasure]])! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test25MaxReturnsTheMaximumBetweenTwoMeasures

	self assert: (self twoMeters max: self oneMeter) = self twoMeters.
	self assert: (self oneMeter max: self twoMeters) = self twoMeters.

	self assert: (self twoMeters max: self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneHundredCentimeters max: self twoMeters) = self twoMeters.

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test26MinReturnsTheMinimumBetweenTwoMeasures

	self assert: (self twoMeters min: self oneMeter) = self oneMeter.
	self assert: (self oneMeter min: self twoMeters) = self oneMeter.

	self assert: (self twoMeters min: self oneHundredCentimeters) = self oneHundredCentimeters.
	self assert: (self oneHundredCentimeters min: self twoMeters) = self oneHundredCentimeters.

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test27BetweenAndReturnsTrueIfAMeasureIsBetweenOtherTwoMeasures

	self assert: (self oneMeter between: self zeroMeters and: self twoMeters).
	self assert: (self oneHundredCentimeters between: self zeroMeters and: self twoMeters).
	
	self deny: (self twoMeters between: self zeroMeters and: self oneMeter).
	self deny: (self twoHundredCentimeters between: self zeroMeters and: self oneMeter).

! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:09'!
test28IntervalOfMeasuresCanBeCreatedBecauseTheyDefineATotalOrder

	self assert: (self oneMeter to: self twoMeters) first=self oneMeter.
	self assert: (self oneMeter to: self twoMeters) last=self twoMeters.
	self assert: (self oneMeter to: self twoMeters) increment =self oneMeter.	

	self assert: (self oneHundredCentimeters to: self twoMeters) first=self oneMeter.
	self assert: (self oneHundredCentimeters to: self twoMeters) last=self twoMeters.
	self assert: (self oneHundredCentimeters to: self twoMeters) increment=self oneCentimeter.	
	! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:16'!
test29MeasureIntervalStepCanBeAnyMeasure

	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) first=self zeroMeters.
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) last=(self twoMeters * 2).
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) increment=self twoMeters.

	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) first=(self twoMeters * 2).
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) last=self zeroMeters.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) increment=self twoMeters negated

	! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:17'!
test30MeasureIntervalSizeReturnsTheNumberOfMeasuresOfTheInterval

	self assert: (self zeroMeters to: (self twoMeters * 2) ) size =5.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self oneMeter negated) size =5.
! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:17'!
test31MeasureIntervalCanBeEnumeratedUsingDo

	| value |
	
	value := 1.
	(self oneMeter to: (self oneMeter * 10)) do: [ :aMeasure |
		self assert: aMeasure amount = value.
		value := value + 1 ].
	
	self assert: value = 11
! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:18'!
test32MeasureIntervalCanBeEnumeratedWithSpecificStep

	| value initialDistance byDistance finalDistance |
	
	initialDistance := self oneMeter.
	byDistance := self twoMeters.
	finalDistance := initialDistance * 9.
	value := initialDistance amount.
		
	(initialDistance to: finalDistance by:  byDistance) do: [ :aMeasure |
		self assert: aMeasure amount = value.
		value := value + byDistance amount ].
	
	self assert:  value = (finalDistance amount + byDistance amount)
! !

!MeasureTest methodsFor: '7 - Polymorphic zero' stamp: 'HernanWilkinson 4/25/2011 17:20'!
test33NothingOnAnyDomainAreEquals

	self assert: self zeroMeters = self zeroSeconds.
	self assert: self zeroSeconds = self zeroKelvin.
	self assert: self zeroKelvin = self zeroMeters! !

!MeasureTest methodsFor: '7 - Polymorphic zero' stamp: 'HernanWilkinson 4/25/2011 17:42'!
test34ZeroCelsiusIsNotNothingOnTemperature

	self deny: self zeroCelsius = self zeroKelvin.
	self deny: self zeroSeconds = self zeroCelsius.
! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'BarroumeresLaje 5/30/2012 21:11'!
thirtyTwoFahrenheits
	
		^Measure of: 32 in: MeasureUnit fahrenheit! !

!MeasureTest methodsFor: 'time measures' stamp: 'HernanWilkinson 4/25/2011 17:29'!
timeExamples

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'time units' stamp: 'HernanWilkinson 4/29/2011 17:10'!
timeUnits

	^self objectsInCategoryOf: thisContext method selector.
	
 ! !

!MeasureTest methodsFor: 'time measures' stamp: 'BarroumeresLaje 6/2/2012 14:12'!
twentyFourHours
	
		^Measure of: 24 in: MeasureUnit hour! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'BarroumeresLaje 6/2/2012 14:12'!
twoCelsius
	
		^Measure of: 2 in: MeasureUnit celsius! !

!MeasureTest methodsFor: 'distance measures' stamp: 'BarroumeresLaje 5/30/2012 21:19'!
twoHundredCentimeters
	
	^Measure of: 200 in: MeasureUnit centimeter ! !

!MeasureTest methodsFor: 'distance measures' stamp: 'BarroumeresLaje 5/30/2012 21:19'!
twoMeters
	
	^Measure of: 2 in: MeasureUnit meter! !

!MeasureTest methodsFor: 'compound measures' stamp: 'BarroumeresLaje 6/4/2012 02:53'!
twoMetersBySecond

	" ^self error: 'este metodo debe devolver la medida 2 metros/segundo'"
	
	^Measure of: 2 in: MeasureUnit meterBySecond ! !

!MeasureTest methodsFor: 'compound measures' stamp: 'BarroumeresLaje 6/4/2012 11:25'!
twoMetersPerSquaredSecond

	"^self error: 'este metodo debe devolver la medida 2 metros/segundoAlCuadrado'"
	
	^Measure of: 2 in: MeasureUnit meterBySquaredSecond ! !

!MeasureTest methodsFor: 'compound measures' stamp: 'BarroumeresLaje 6/4/2012 02:08'!
twoMetersTimesSecond

"	^self error: 'este metodo debe devolver la medida 2 metros*segundo'"
	^Measure of: 2 in: MeasureUnit meterPerSecond ! !

!MeasureTest methodsFor: 'time measures' stamp: 'BarroumeresLaje 6/2/2012 14:13'!
twoSeconds
	
		^Measure of: 2 in: MeasureUnit second! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:34'!
units 

	^ OrderedCollection new
		addAll: self distanceUnits;
		addAll: self temperatureUnits;
		addAll: self timeUnits;
		yourself ! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'BarroumeresLaje 5/30/2012 21:09'!
zeroCelsius
	
		^Measure of: 0 in: MeasureUnit celsius! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'BarroumeresLaje 5/30/2012 21:13'!
zeroKelvin
	
	^Measure of: 0 in: MeasureUnit kelvin! !

!MeasureTest methodsFor: 'distance measures' stamp: 'BarroumeresLaje 5/30/2012 21:19'!
zeroMeters

	^Measure of: 0 in: MeasureUnit meter.! !

!MeasureTest methodsFor: 'time measures' stamp: 'BarroumeresLaje 5/30/2012 21:13'!
zeroSeconds
	
	^Measure of: 0 in: MeasureUnit second! !
